;; Microsoft logo trampled by Monty Python foot

; foot is 284x288
(define foot-width 284)
(define foot-height 288)
; logo is 251x76
(define logo-width 251)
(define logo-height 76)
; stage is 300x310
(define ms-width 300)
(define ms-height 310)
; duration is 4 seconds
(define ms-duration 4000)

; ticker height is 21 pixels
(define ticker-height 21)

; White background
(define (ms-background)
  (ani-object ANI_FILLRECT)
  (ani-properties ANI_WIDTH ms-width ANI_HEIGHT ms-height ANI_COLOR WHITE))

; I know where I *don't* want to go
; Only use *half* the animation time for the movement
(define (ms-logo)
  (ani-object ANI_PIXMAP)
  (ani-properties ANI_TEXT "toady.xpm")
  (ani-properties ANI_X (/ (- ms-width logo-width) 2))
  (ani-properties ANI_Y (- ms-height logo-height ticker-height 1))
  ; start dropping after 1600 ms
  (ani-time 1600)
  (ani-time (/ ms-duration 2))
  (ani-properties ANI_Y (- ms-height ticker-height)))


; Fine art
(define (ms-foot)
  (ani-object ANI_PIXMAP)
  (ani-properties ANI_TEXT "mpfoot.xpm")
  (ani-properties ANI_X (/ (- ms-width foot-width) 2))
  (ani-properties ANI_Y (- 0 foot-height))
  ; start dropping after 500 ms
  (ani-time 500)
  (ani-time (/ ms-duration 2))
  (ani-properties ANI_Y (- ms-height foot-height ticker-height 1)))

(define (textblock y h t text)
;  (ani-object ANI_FILLRECT)
  (ani-object ANI_FILLELLIPSE)
  (ani-properties ANI_VISIBLE 0)
  (ani-time t)
  (ani-properties ANI_VISIBLE 1)
;  (ani-properties ANI_X 0 ANI_Y y)
;  (ani-properties ANI_WIDTH ms-width ANI_HEIGHT h)
  (ani-properties ANI_X 10 ANI_Y (+ y 10))
  (ani-properties ANI_WIDTH (- ms-width 20) ANI_HEIGHT (- h 20))
;  (ani-properties ANI_COLOR WHITE)
  (ani-properties ANI_COLOR MAGENTA)
  (ani-object ANI_ELLIPSE)
  (ani-properties ANI_VISIBLE 0)
  (ani-time t)
  (ani-properties ANI_VISIBLE 1)
;  (ani-properties ANI_X 0 ANI_Y y)
;  (ani-properties ANI_WIDTH ms-width ANI_HEIGHT h)
  (ani-properties ANI_X 10 ANI_Y (+ y 10))
  (ani-properties ANI_WIDTH (- ms-width 20) ANI_HEIGHT (- h 20))
;  (ani-properties ANI_COLOR WHITE)
  (ani-properties ANI_COLOR CYAN)
  (ani-object ANI_STRING)
  (ani-properties ANI_VISIBLE 0)
  (ani-time t)
  (ani-properties ANI_TEXT text)
  (ani-properties ANI_FONT (+ HELVETICA SIZE_24 BOLD ITALIC))
  (ani-properties ANI_COLOR CYAN)
  (ani-properties ANI_X 110 ANI_Y (+ y (/ h 2) 8))
  (ani-properties ANI_VISIBLE 1))

; Put up the words "This is great fun" during the final second
(define (ms-this-is-great-fun)
  (let ((h (/ (- ms-height ticker-height) 4)))
    (textblock 0 h (- ms-duration 1000) "This")
    (textblock h h (- ms-duration 750) "Is")
    (textblock (* 2 h) h (- ms-duration 500) "Great")
    (textblock (* 3 h) h (- ms-duration 250) "Fun!")))


(define ticker-message
  "This was brought to you by Egon Animator (C) 1997 Ulric Eriksson. No Warranty.")

; A ticker tape
(define (ms-ticker)
  ; a line
  (ani-object ANI_LINE)
  (ani-properties ANI_X 0 ANI_Y (- ms-height ticker-height 1))
  (ani-properties ANI_WIDTH ms-width ANI_HEIGHT 0)

  ; yellow background
  (ani-object ANI_FILLRECT)
  (ani-properties ANI_X 0 ANI_Y (- ms-height ticker-height))
  (ani-properties ANI_WIDTH ms-width ANI_HEIGHT ticker-height)
  (ani-properties ANI_COLOR YELLOW)

  ; message scrolling sideways right to left
  (ani-object ANI_STRING)
  (ani-properties ANI_TEXT ticker-message)
  (ani-properties ANI_X ms-width ANI_Y (- ms-height 5))
  (ani-time (/ ms-duration 2))
  (ani-time ms-duration)
  (ani-properties ANI_X (- 0 ms-width ms-width)))

; Now put it all together
(define (ms)
  (ani-duration ms-duration)
  (ani-geometry ms-width ms-height)
  (ms-background)
  (ms-logo)
  (ms-foot)
  (ms-this-is-great-fun)
  (ms-ticker))

(ms)

